#include<Servo.h>
#include <DigitShield.h>

const int TriggerPin = 7;            //초음파 센서 Trigger 연결핀
const int EchoPin = 8;               //초음파 센서 Echo 연결핀
const int motorSignalPin = 9;        //서보모터 시그널 연결 핀 
const int buzzer = 11;               //부져 연결핀(+단자)

const int startingAngle = 90;        //서보모터 시작 위치 90도 시작  
const int minimumAngle = 6;          //서보모터 최소 회전각
const int maximumAngle = 175;        //서보모터 최대 회전각
const int rotationSpeed = 1;         //서보모터 움직이는 스피트


Servo motor;
void setup(void) 
{
    pinMode(TriggerPin, OUTPUT);
    pinMode(EchoPin, INPUT);
    pinMode(buzzer, OUTPUT);
    motor.attach(motorSignalPin);
    Serial.begin(9600);
    DigitShield.begin();
}
void loop(void)
{
    //서보모터 동작 관련 코드
    static int motorAngle = startingAngle;
    static int motorRotateAmount = rotationSpeed;
    motor.write(motorAngle);
    delay(10);
    SerialOutput(motorAngle, CalculateDistance());
    motorAngle += motorRotateAmount;
    if(motorAngle <= minimumAngle || motorAngle >= maximumAngle) {
        motorRotateAmount = -motorRotateAmount;
    }
}

//초음파 센서 시그널 정보 처리 코드
int CalculateDistance(void)
{
   
    digitalWrite(TriggerPin, HIGH);
    delayMicroseconds(10);
    digitalWrite(TriggerPin, LOW);
    
    //타임아웃 기능 추가 20000 -> 2.8m / 40000 -> 2m(반사정도에 따라 다름)
    long duration = pulseIn(EchoPin, HIGH, 20000); 
    float distance = duration * 0.017F;  

    //감지 거리에 따라 부져 동작 1cm~10cm이내 일때 부저 동작 (타임 아웃시 0으로 출력하기 때문에 제외) 
    if (distance <= 10 &  distance >= 1){
      digitalWrite(buzzer, HIGH);
     }
     else {
      digitalWrite(buzzer, LOW);
     }
      return int(distance);
      
}

//입력된 시그널 정보들 종합하여 시리얼 포트 및 세그먼트 쉴드로 출력하기
void SerialOutput(const int angle, const int distance)
{
    String angleString = String(angle);
    String distanceString = String(distance);
        Serial.println("angle : " + angleString + "  distance : " + distanceString );
        int value = distance;
        DigitShield.setValue(value);
}
